unit EmployeeChangeThreadu;

interface

uses
  Classes, adstable, DB, adsdata, adsfunc, adscnnct;

type
  TEmployeeChangeMonitor = class(TThread)
  private
    { Private declarations }
    Connection: TAdsConnection;
    AdsQuery: TAdsQuery;
    procedure UpdateStatusBar;
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: Boolean;
      AdsConnection: TAdsConnection); overload;
    destructor Destroy; override;
  end;

implementation

uses mainformu;

{ TNotificationMonitor }

constructor TEmployeeChangeMonitor.Create(CreateSuspended: Boolean;
  AdsConnection: TAdsConnection);
begin
  inherited Create(True);
  Connection := TAdsConnection.Create(nil);
  Connection.ConnectPath := AdsConnection.ConnectPath;
  Connection.AdsServerTypes := AdsConnection.AdsServerTypes;
  Connection.Username := AdsConnection.Username;
  Connection.Password := AdsConnection.Password;
  Connection.LoginPrompt := False;
  Connection.Connect;
  AdsQuery := TAdsQuery.Create(Connection);
  Adsquery.AdsConnection := Connection;
  AdsQuery.SQL.Text :=
    'EXECUTE PROCEDURE sp_CreateEvent(''EmployeeChanged'', 2);';
  AdsQuery.ExecSQL;
  if not CreateSuspended then
    Resume;
end;

destructor TEmployeeChangeMonitor.Destroy;
begin
  AdsQuery.SQL.Text :=
    'EXECUTE PROCEDURE sp_DropEvent(''EmployeeChanged'', 2);';
  Connection.Disconnect;
  AdsQuery.Free;
  Connection.Free;
  inherited;
end;

procedure TEmployeeChangeMonitor.Execute;
const
  EventCountPos = 1;
var
  EventCount: Integer;
begin
  AdsQuery.SQL.Text :=
    'EXECUTE PROCEDURE sp_WaitForEvent(''EmployeeChanged'', 10000, 0, 2);';
  //Loop until the thread is terminated
  while True do
  begin
    if Self.Terminated then exit;
    AdsQuery.Open;
    EventCount := AdsQuery.Fields[EventCountPos].AsInteger;
    if EventCount <> 0 then
    begin
      if Self.Terminated then exit;
      Synchronize(UpdateStatusBar);
    end;
    AdsQuery.Close;
  end;
end;

procedure TEmployeeChangeMonitor.UpdateStatusBar;
const
  StringDataPos = 2;
begin
  MainForm.StatusBar1.Simpletext := 'Updated ' +
    AdsQuery.Fields[StringDataPos].AsString;
end;

end.
