(*
Notice of Copyright Ownership

Copyright (c) 2003-2010 Jensen Data Systems. Inc.

This code was produced by and is copyrighted by Jensen Data Systems, Inc. All data 
mentioned or referred to, including names, addresses, phone numbers, descriptions, 
and images, are fictitious. Any resemblance to actual persons, companies, and products 
is purely coincidental.

This code is intended to be used in conjunction with database examples and 
descriptions found in the book: 
1. Advantage Database Server: A Developer's Guide, 2nd Edition 
by Cary Jensen, Ph.D. and Loy Anderson, Ph.D. (2010, Jensen Data Systems, Inc.)

For information on purchasing this book, visit:
http://www.JensenDataSystems.com/ADSBook10
*)

unit mainform;

interface

uses
  Windows, Messages, SysUtils,
{$IFDEF MSWINDOWS}
  Variants,
{$ENDIF}
  Classes, Graphics, Controls, Forms,
  Dialogs, adsdictionary, DB, adsdata, adsfunc, adstable, adscnnct, Grids,
  DBGrids, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    SELECTText: TEdit;
    DoSelect: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    ListProductsBtn: TButton;
    ClearListBtn: TButton;
    ShowInvoicesBtn: TButton;
    ProductList: TListBox;
    ParamText: TEdit;
    Label2: TLabel;
    CustNoText: TEdit;
    Label3: TLabel;
    GetAddressBtn: TButton;
    SetAddressBtn: TButton;
    Label5: TLabel;
    Label6: TLabel;
    OldAddressText: TEdit;
    NewAddressText: TEdit;
    ShowInvoiceBtn: TButton;
    SetIndexBtn: TButton;
    SearchText: TEdit;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    StartRange: TEdit;
    EndRange: TEdit;
    SetRangeBtn: TButton;
    Label9: TLabel;
    TableNameText: TEdit;
    CreateTableBtn: TButton;
    ChangePasswordBtn: TButton;
    DBGrid1: TDBGrid;
    AdsConnection1: TAdsConnection;
    AdsTable1: TAdsTable;
    AdsDictionary1: TAdsDictionary;
    Label10: TLabel;
    FilterText: TEdit;
    FilterBtn: TButton;
    AdsStoredProc1: TAdsStoredProc;
    AdsQuery1: TAdsQuery;
    DataSource1: TDataSource;
    AdsQuery2: TAdsQuery;
    CallStoredProcBtn: TButton;
    procedure DoSelectClick(Sender: TObject);
    procedure GetAddressBtnClick(Sender: TObject);
    procedure SetAddressBtnClick(Sender: TObject);
    procedure ShowInvoicesBtnClick(Sender: TObject);
    procedure ShowInvoiceBtnClick(Sender: TObject);
    procedure SetIndexBtnClick(Sender: TObject);
    procedure SearchTextChange(Sender: TObject);
    procedure SetRangeBtnClick(Sender: TObject);
    procedure FilterBtnClick(Sender: TObject);
    procedure CallStoredProcBtnClick(Sender: TObject);
    procedure ListProductsBtnClick(Sender: TObject);
    procedure ClearListBtnClick(Sender: TObject);
    procedure CreateTableBtnClick(Sender: TObject);
    procedure ChangePasswordBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DoSelectClick(Sender: TObject);
begin
  if AdsQuery1.Active then
    AdsQuery1.Close;
  AdsQuery1.SQL.Text := SELECTText.Text;
  AdsQuery1.Open;
  DataSource1.DataSet := AdsQuery1;
end;

procedure TForm1.GetAddressBtnClick(Sender: TObject);
begin
  if AdsTable1.Active then
    AdsTable1.Close;
  AdsTable1.TableName := 'CUSTOMER';
  AdsTable1.IndexName := 'Customer ID';
  AdsTable1.Open;
  if AdsTable1.FindKey([CustNoText.Text]) then
    OldAddressText.Text := AdsTable1.FieldByName('Address').AsString
  else
    ShowMessage('Customer ID ' + CustNoText.Text + ' not found');
  DataSource1.DataSet := AdsTable1;
end;

procedure TForm1.SetAddressBtnClick(Sender: TObject);
begin
  if AdsTable1.Active then
    AdsTable1.Close;
  AdsTable1.TableName := 'CUSTOMER';
  AdsTable1.IndexName := 'Customer ID';
  AdsTable1.Open;
  if AdsTable1.FindKey([CustNoText.Text]) then
  begin
    AdsTable1.Edit;
    AdsTable1.FieldByName('Address').AsString := NewAddressText.Text;
    AdsTable1.Post;
  end
  else
    ShowMessage('Customer ID ' + CustNoText.Text + ' not found');
  DataSource1.DataSet := AdsTable1;
end;

procedure TForm1.ShowInvoicesBtnClick(Sender: TObject);
begin
  if AdsQuery2.Active then
    AdsQuery2.Close;
  if ParamText.Text = '' then
  begin
    ShowMessage('Please enter a customer number');
    Exit;
  end;
  AdsQuery2.Params[0].AsInteger := StrToInt(ParamText.Text);
  AdsQuery2.Open;
  DataSource1.DataSet := AdsQuery2;
end;

procedure TForm1.ShowInvoiceBtnClick(Sender: TObject);
begin
  if AdsTable1.Active then
    AdsTable1.Close;
  AdsTable1.TableName := 'INVOICE';
  AdsTable1.Open;
  DataSource1.DataSet := AdsTable1;
end;

procedure TForm1.SetIndexBtnClick(Sender: TObject);
begin
  if (AdsTable1.TableName <> 'INVOICE') and (AdsTable1.Active) then
    AdsTable1.Close;
  AdsTable1.IndexName := 'Invoice No';
end;

procedure TForm1.SearchTextChange(Sender: TObject);
begin
  if (not AdsTable1.Active) or (AdsTable1.TableName <> 'INVOICE') or
    (AdsTable1.IndexName <> 'Invoice No') then
  begin
    ShowMessage('Click Show Invoice Table and Select ' +
        'Invoice No Index before performing an ' + 'incremental search');
    Exit;
  end;
  AdsTable1.FindNearest([SearchText.Text]);
end;

procedure TForm1.SetRangeBtnClick(Sender: TObject);
begin
  if SetRangeBtn.Caption = 'Set Range' then
  begin
    if (not AdsTable1.Active) or (AdsTable1.TableName <> 'INVOICE') or
      (AdsTable1.IndexName <> 'Invoice No') then
    begin
      ShowMessage('Click Show Invoice Table ' + 'and Select Invoice ' +
          'No Index before setting a range');
      Exit;
    end;
    AdsTable1.SetRange([StartRange.Text], [EndRange.Text]);
    SetRangeBtn.Caption := 'Clear Range';
  end
  else
  begin
    AdsTable1.CancelRange;
    SetRangeBtn.Caption := 'Set Range';
  end;
end;

procedure TForm1.FilterBtnClick(Sender: TObject);
begin
  if FilterBtn.Caption = 'Drop Filter' then
  begin
    AdsTable1.Filtered := False;
    FilterBtn.Caption := 'Set Filter';
  end
  else
  begin
    if (not AdsTable1.Active) or (not(DataSource1.DataSet is TAdsTable)) then
    begin
      ShowMessage('Please open a table before ' + 'setting a filter');
      Exit;
    end;
    AdsTable1.Filter := FilterText.Text;
    AdsTable1.Filtered := True;
    FilterBtn.Caption := 'Drop Filter';
  end;
end;

procedure TForm1.CallStoredProcBtnClick(Sender: TObject);
begin
  if AdsStoredProc1.Active then
    AdsStoredProc1.Close;
  if ParamText.Text = '' then
  begin
    ShowMessage('Please enter a customer number');
    Exit;
  end;
  AdsStoredProc1.Params[0].Value := ParamText.Text;
  try
    AdsStoredProc1.Open;
  except
    on e: Exception do
      ShowMessage(e.Message);
  end;
  DataSource1.DataSet := AdsStoredProc1;
end;

procedure TForm1.ListProductsBtnClick(Sender: TObject);
begin
  DataSource1.DataSet := nil;
  if AdsTable1.Active then
    AdsTable1.Close;
  AdsTable1.TableName := 'PRODUCTS';
  AdsTable1.Open;
  AdsTable1.First;
  while not AdsTable1.EOF do
  begin
    ProductList.Items.Add
      (AdsTable1.Fields[0].AsString + '      ' + AdsTable1.Fields[1].AsString);
    AdsTable1.Next;
  end;
  AdsTable1.Close;
end;

procedure TForm1.ClearListBtnClick(Sender: TObject);
begin
  ProductList.Items.Clear;
end;

procedure TForm1.CreateTableBtnClick(Sender: TObject);
var
  AdminConnection: TAdsConnection;
  AdminTable: TAdsTable;
  StringList: TStringList;
  i: Integer;
begin
  if TableNameText.Text = '' then
  begin
    ShowMessage('Please enter the name of the ' + 'table to create');
    Exit;
  end;
  // Create Connection and Table objects
  AdminConnection := TAdsConnection.Create(nil);
  AdminConnection.Name := 'Admin';
  AdminTable := TAdsTable.Create(AdminConnection);
  AdminTable.DatabaseName := AdminConnection.Name;
  StringList := TStringList.Create;
  try
    // Configure Connection and Table objects
    AdminConnection.AliasName := AdsConnection1.AliasName;
    AdminConnection.AdsServerTypes := AdsConnection1.AdsServerTypes;
    AdminConnection.Username := 'adssys';
    // Add the password if ADSSYS uses a password
    // AdminConnection.Password := 'password';
    AdminConnection.LoginPrompt := False;
    AdminConnection.IsConnected := True;
    AdminConnection.GetTableNames(StringList, TableNameText.Text);
    for i := 0 to Pred(StringList.Count) do
      if AnsiCompareText(StringList.Strings[i], TableNameText.Text) = 0 then
      begin
        ShowMessage('This table already exists. ' + 'Cannot create');
        Exit;
      end;
    // Define new table structure and create it
    with AdminTable.FieldDefs do
    begin
      Add('Full Name', ftString, 30);
      Add('Date of Birth', ftDate);
      with AddFieldDef do
      begin
        Name := 'Credit Limit';
        DataType := ftBCD;
        Precision := 20;
        Size := 4;
      end;
      Add('Active', ftBoolean);
    end;
    AdminTable.TableType := ttAdsADT;
    AdminTable.TableName := TableNameText.Text;
    AdminTable.CreateTable;
    // Configure and connect the AdsDictionary object
    AdsDictionary1.AliasName := AdminConnection.AliasName;
    AdsDictionary1.AdsServerTypes := AdminConnection.AdsServerTypes;
    AdsDictionary1.Username := AdminConnection.Username;
    AdsDictionary1.Password := AdminConnection.Password;
    AdsDictionary1.LoginPrompt := False;
    AdsDictionary1.Connect;
    StringList.Clear;
    AdsDictionary1.GetGroupNames(StringList);
    if StringList.Count = 0 then
    begin
      ShowMessage('No groups to grant rights to');
      Exit;
    end;
    // Grant access rights to all groups
    for i := 0 to Pred(StringList.Count) do
      if Pos('DB:', StringList.Strings[i]) = 0 then
          AdsDictionary1.SetObjectAccessRights(TableNameText.Text,
            StringList.Strings[i], 'RW');
  finally
    // cleanup
    AdsDictionary1.Disconnect;
    StringList.Free;
    AdminTable.Free;
    AdminConnection.IsConnected := False;
    AdminConnection.Free;
  end;
  ShowMessage('The ' + TableNameText.Text + ' table has been ' +
      'created, with rights granted to all groups');
end;

procedure TForm1.ChangePasswordBtnClick(Sender: TObject);
var
  Username: String;
  OldPass: String;
  NewPass1: AnsiString;
  NewPass2: AnsiString;
{$HINTS OFF}
  function CheckPass(UName, UPass: String): Boolean;
  var
    TempConnection: TAdsConnection;
  begin
    result := False;
    TempConnection := TAdsConnection.Create(nil);
    try
      TempConnection.AliasName := AdsConnection1.AliasName;
      TempConnection.AdsServerTypes := AdsConnection1.AdsServerTypes;
      TempConnection.Username := UName;
      TempConnection.Password := UPass;
      TempConnection.LoginPrompt := False;
      try
        TempConnection.IsConnected := True;
      except
        result := False;
      end;
      result := True;
    finally
      TempConnection.IsConnected := False;
      TempConnection.Free;
    end;
  end; // CheckPass
{$HINTS ON}

begin
  Username := AdsConnection1.Username;
  OldPass := 'Enter password';
  OldPass := InputBox('Password', 'Enter your current password', OldPass);
  if OldPass = 'Enter password' then
    Exit;

  if not CheckPass(Username, OldPass) then
  begin
    ShowMessage('Cannot validate your current password. ' +
        'Cannot change password');
    Exit;
  end;

  NewPass1 := '';
  NewPass2 := '';
  NewPass1 := InputBox('Password', 'Enter your new Password', NewPass1);
  if NewPass1 = '' then
  begin
    ShowMessage('Password cannot be blank. ' + 'Cannot change password');
    Exit;
  end;
  NewPass2 := InputBox('Password', 'Confirm your new password', NewPass2);
  if NewPass1 <> NewPass2 then
  begin
    ShowMessage('Passwords did not match. ' + 'Cannot change password');
    Exit;
  end;

  // Connect AdsDictionary1 and change password
  AdsDictionary1.AliasName := AdsConnection1.AliasName;
  AdsDictionary1.AdsServerTypes := AdsConnection1.AdsServerTypes;
  AdsDictionary1.Username := AdsConnection1.Username;
  AdsDictionary1.Password := OldPass;
  AdsDictionary1.LoginPrompt := False;
  AdsDictionary1.Connect;
  AdsDictionary1.SetUserProperty(AdsConnection1.Username, ADS_DD_USER_PASSWORD,
    PAnsiChar(NewPass1), StrLen(PAnsiChar(NewPass1)) + 1);
  AdsDictionary1.Disconnect;

  ShowMessage('Password successfully changed. ' +
      'New password will be valid next time you connect');
end;

end.
